#include <stdio.h>

/*
 * Kopieren von Strings von Hand implementiert
 */

void my_strcpy1(char t[], char s[]) {
	int i = 0;
	/* Bem.: Wert einer Zuweisung ist der zugewiesene Wert */
	for (i = 0; (t[i] = s[i]) != 0; i++);
}

void my_strcpy2(char *t, char *s) {
	for (; (*t = *s) != 0; t++, s++);
}

void my_strcpy3(char *t, char *s) {
	/* Inkrementierung findet erst danach statt!! */
	while ((*t++ = *s++) != 0);
}

void my_strcpy4(char *t, char *s) {
	/*
	 * in diesem Fall koennen wir den zugewiesenen Wert
	 * direkt als bool. Wert verwenden, da != 0 in C ja
	 * fuer den Bool. Wert TRUE steht!
	 */
	while (*t++ = *s++); /* gewollt?! In diesem Fall schon! */
}

int main() {
	char s1[] = "Hallo Welt!";
	char s2[20];

	printf("s1 = \"%s\"\n", s1);

	my_strcpy1(s2, s1);

	printf("s2 = \"%s\"\n", s2);

	return 0;
}
